namespace Reminder;

public partial class Form1 : Form
{
    private static DateTime TimeRemaining;

    public Form1()
    {
        InitializeComponent();
        TimeRemaining = DateTime.Now;
    }

    private void Form1_Resize(object sender, EventArgs e)
    {
        if (WindowState == FormWindowState.Minimized)
        {
            Hide();
        }
    }

    private void notifyIcon1_MouseDoubleClick(object sender, MouseEventArgs e)
    {
        Show();
        WindowState = FormWindowState.Normal;
    }

    private void timer1_Tick(object sender, EventArgs e)
    {
        if (WindowState != FormWindowState.Minimized)
        {
            DisplayRemainingTime();
        }
    }

    private void Form1_Shown(object sender, EventArgs e)
    {
        DisplayRemainingTime();
    }

    private void Form1_FormClosing(object sender, FormClosingEventArgs e)
    {
        WindowState = FormWindowState.Minimized;
        e.Cancel = true;
    }

    private void timerBaloon_Tick(object sender, EventArgs e)
    {
        notifyIcon1.ShowBalloonTip(2000, "Stop working!", "Time to exercise!", ToolTipIcon.Info);
        Show();
        timerBaloon.Stop();
    }

    private void tsmiExit_Click(object sender, EventArgs e)
    {
        notifyIcon1.Visible = false;
        Environment.Exit(0);
    }

    private void btnRestart_Click(object sender, EventArgs e)
    {
        TimeRemaining = DateTime.Now;
        DisplayRemainingTime();
        timerBaloon.Start();
    }

    private void DisplayRemainingTime()
    {
        string remainingTime =
            (new TimeSpan(0, 0, timerBaloon.Interval / 1000) - (DateTime.Now - TimeRemaining)).ToString(@"hh\:mm\:ss");
        label1.Text = remainingTime;
    }
}